package adapter;

import java.util.Map;
import java.util.Collection;
import java.util.Iterator;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Set;
//import java.util.ListIterator;

public class MapAdapter
//extends Hashtable non facciamo un class adapter
implements Map
{
	Hashtable hash = new Hashtable();

	public int size()
	{
		return hash.size();
	}

	public boolean isEmpty()
	{
		return hash.isEmpty();
	}

	public Enumeration keys()
	{
		return hash.keys();
	}

	public Enumeration elements()
	{
		return hash.elements();
	}

	public boolean contains(Object o)
	{
		return hash.contains(o);
	}

	public boolean containsValue(Object o)
	{
		Enumeration enumeration = hash.elements();
		if(o == null)
		{
			while(enumeration.hasMoreElements())
			{
				if(enumeration.nextElement() == null)
				{
					return true;
				}
			}
		}
		else
		{
			while(enumeration.hasMoreElements())
			{
				if(o.equals(enumeration.nextElement()))
				{
					return true;
				}
			}
		}
		return false;
	}

	public boolean containsKey(Object k)
	{
		return hash.containsKey(k);
	}

	public Object get(Object key)
	{
		return hash.get(key);
	}

	public Object put(Object k, Object v)
	{
		return hash.put(k, v);
	}

	protected void rehash()
	{
		//hash.rehash();
	}

	public Object remove(Object k)
	{
		return hash.remove(k);
	}

	public void putAll(Map m)
	{
		Set set = m.entrySet();
		Iterator iter = set.iterator();
		while(iter.hasNext())
		{
			Map.Entry entry = (Map.Entry)iter.next();
			hash.put(entry.getKey(), entry.getValue());
		}
	}

	public void clear()
	{
		hash.clear();
	}

	public Object clone()
	{
		MapAdapter retval = new MapAdapter();
		retval.putAll(this);
		return retval;
	}

	public String toString()
	{
		return hash.toString();
	}

	public Set keySet()
	{
		Set set = new SetAdapter();
		Enumeration enumeration = hash.keys();
		while(enumeration.hasMoreElements())
		{
			set.add(enumeration.nextElement());
		}
		return set;
	}

	public Set entrySet()
	{
		Set retval = new SetAdapter();
		Enumeration enumeration = hash.keys();
		while(enumeration.hasMoreElements())
		{
			Entry e = new Entry();
			e.key = enumeration.nextElement();
			e.value = hash.get(e.key);
			retval.add(e);
		}
		return retval;
	}

	public Collection values()
	{
		Collection retval = new ListAdapter();
		Enumeration enumeration = hash.elements();
		while(enumeration.hasMoreElements())
		{
			retval.add(enumeration.nextElement());
		}
		return retval;
	}

	public boolean equals(Object o)
	{
		MapAdapter ma = (MapAdapter)o;
		return hash.equals(ma.hash);
	}

	public int hashCode()
	{
		return hash.hashCode();
	}

	class Entry
	implements Map.Entry
	{
		Object key, value;

		public Object getKey()
		{
			return key;
		}

		public Object getValue()
		{
			return value;
		}

		public Object setValue(Object o)
		{
			Object retval = value;
			value = o;
			return retval;
		}

		public boolean equals(Object o)
		{
			Map.Entry entry2 = (Map.Entry)o;
			if(!key.equals(entry2.getKey()))
			{
				return false;
			}

			if(value == null)
			{
				if(entry2.getValue() == null)
				{
					return true;
				}
			}
			else
			{
				if(value.equals(entry2.getValue()))
				{
					return true;
				}
			}
			return false;
		}

		public String toString()
		{
			String retval = "key = ";
			retval.concat(String.valueOf(key) + "; ");
			retval = retval.concat(String.valueOf(value));
			return retval;
		}

		public int hashCode()
		{
			return toString().hashCode();
		}
	}
}
