package channel;

import java.util.*;

public class OsservatoImplMap
implements Osservato
{
	Map<Osservatore, Osservatore> oss = new HashMap<Osservatore, Osservatore>();

	public void register(Osservatore o)
	{
		if(oss.put(o, o) != null)
		{
			throw new RuntimeException("Doppia registrazione di <" + String.valueOf(o) + ">");
		}
	}

	public boolean unregister(Osservatore o)
	{
		return (oss.remove(o) != null);
	}

	public void update(Event e)
	{
		Set<Osservatore> keys = oss.keySet();
		Iterator<Osservatore> iter = keys.iterator();
		while(iter.hasNext())
		{
			iter.next().notify(e);
		}
	}
}
