package channel;

import java.util.*;

public class OsservatoTipatoImplList
implements OsservatoTipato
{
	List<Entry> osservatori = new LinkedList<Entry>();
	
	public void register(OsservatoreTipato o, Event interessato)
	{
		Entry e = new Entry(o, interessato);
		osservatori.add(e);
	}

	public boolean unregister(OsservatoreTipato o, Event interessato)
	{
		Entry e = new Entry(o, interessato);
		return osservatori.remove(e);
	}

	public void update(Event e)
	{
		System.out.println("OsservatoTipato <" + toString() + "> ricevo update <" + String.valueOf(e) + ">");

		Iterator<Entry> iter = osservatori.iterator();
		while(iter.hasNext())
		{
			Entry entry = iter.next();
			//if(e instanceof entry.tipoE) NON FUNZIONA, instanceof solo tipo statico
			if(entry.clazz.isInstance(e))
			{
				entry.oss.notify(e);
			}
		}
	}

	class Entry
	{
		OsservatoreTipato oss;
		Event tipoE;
		Class clazz;

		private Entry()
		{
			System.err.println("Non deve essere usato");
		}

		Entry(OsservatoreTipato o, Event e)
		{
			oss = o;
			tipoE = e;
			clazz = e.getClass();
		}

		public boolean equals(Object o)
		{
			if(! (o instanceof Entry))
			{
				return false;
			}
			Entry e = (Entry)o;
			return ( (e.oss.equals(oss)) && (e.tipoE.equals(tipoE)));
		}
	}
}
