package command;

import java.io.*;
import java.util.*;

public class Dvd
extends Media
{
	String regista;
	Integer annoUscita;
	List<String> cast;

	private Dvd()
	{
		this(null, null, null, null, null);
	}

	Dvd(String cat, String tit, String reg, Integer anno, List<String> ca)
	{
		categoria = cat;
		titolo = tit;
		regista = reg;
		annoUscita = anno;
		cast = ca;
	}


	public static Media getInstance(BufferedReader br) throws IOException
	{
		String cat, tit, reg;
		Integer anno;
		List<String> ca = new ArrayList<String>();

		cat = br.readLine();
		if(cat == null || cat.equals(""))
		{
			throw new IncompleteDataException("Cannot read categoria");
		}

		tit = br.readLine();
		if(tit == null || tit.equals(""))
		{
			throw new IncompleteDataException("Cannot read titolo");
		}

		reg = br.readLine();
		if(reg == null || reg.equals(""))
		{
			throw new IncompleteDataException("Cannot read regista");
		}

		try
		{
			anno = new Integer(br.readLine());
		}
		catch(NumberFormatException nfe)
		{
			nfe.printStackTrace();
			throw new IncompleteDataException("Cannot read anno uscita " + nfe.toString());
		}

		String tmp = br.readLine();
		if(tmp == null || tmp.equals(""))
		{
			throw new IncompleteDataException("Cannot read cast");
		}
		StringTokenizer st = new StringTokenizer(tmp, ";");
		while(st.hasMoreTokens())
		{
			tmp = st.nextToken();
			tmp = tmp.trim();
			ca.add(tmp);
		}

		return new Dvd(cat, tit, reg, anno, ca);
	}

	/* se ho la toString con reflection non richiede overwrite
	public String toString()
	{
		String retval = "DVD " + super.toString();
		retval = retval.concat("; Regista: " + regista);
		retval = retval.concat("; Anno di uscita: " + annoUscita);
		retval = retval.concat("; Cast: " + cast);
		return retval;
	}
	*/
}
