package command;

import java.io.*;
import java.util.*;

public class Mediateca
{
	BufferedReader stdin = null;
	Map<String, Command> comandi = null;
	
	public Mediateca()
	{
		stdin = new BufferedReader(new InputStreamReader(System.in));
		comandi = new HashMap<String, Command>();
	}

	public static void main(String[] argv)
	{
		Mediateca m = new Mediateca();
		m.execute(argv);
	}

	public void execute(String[] args)
	{
		while(true)
		{
			String comm = null;
			System.out.print("Command? > ");
			try
			{
				comm = stdin.readLine();
			}
			catch(IOException ioe)
			{
				ioe.printStackTrace();
				continue;
			}
			Command c = comandi.get(comm);
			if(c == null)
			{
				try
				{
					Class clazz = Class.forName(comm);
					c = (Command)clazz.newInstance();
				}
				catch(ClassNotFoundException cnfe)
				{
					cnfe.printStackTrace();
					System.err.println("Command <" + comm + "> not available");
				}
				catch(InstantiationException ie)
				{
					ie.printStackTrace();
					System.err.println("Command <" + comm + "> not available");
				}
				catch(IllegalAccessException iae)
				{
					iae.printStackTrace();
					System.err.println("Command <" + comm + "> not available");
				}
				finally
				{
					if(c == null)
					{
						continue;
					}
					else
					{
						comandi.put(comm, c);
					}
				}
			}

			try
			{
				System.out.println(c.getDescription());
				c.execute(this, stdin);
			}
			catch(ExecuteException ee)
			{
				ee.printStackTrace();
				System.err.println("Command <" + comm + "> failed");
			}
		}
	}
}
