package command;

import java.io.*;
import java.util.*;

public class ReadFromFile
implements Command
{
	Map<String, List<Media>> tipi;
	Map<String, List<Media>> titoli;
	MediaFactory mf = null;

	public ReadFromFile()
	{
		tipi = new HashMap<String, List<Media>>();
		titoli = new HashMap<String, List<Media>>();
		mf = new MediaFactory();
	}

	public void execute(Object state, Object params) throws ExecuteException
	{
		//Mediateca m = (Mediateca)state;
		BufferedReader stdin = (BufferedReader)params;

		System.out.print("Nome file? > ");
		String nome = null;
		try
		{
			nome = stdin.readLine();
		}
		catch(IOException ioe)
		{
			ExecuteException ee = new ExecuteException(ioe.getMessage());
			ee.initCause(ioe);
			throw ee;
		}

		BufferedReader br = null;
		try
		{
			br = new BufferedReader(new FileReader(nome));
		}
		catch(IOException ioe)
		{
			ExecuteException ee = new ExecuteException(ioe.getMessage());
			ee.initCause(ioe);
			throw ee;
		}

		List<Media> l = null;
		Media m = null;

		while( (m = mf.nextMedia(br)) != null)
		{
			l = titoli.get(m.titolo);
			if(l == null)
			{
				l = new LinkedList<Media>();
				titoli.put(m.titolo, l);
			}
			l.add(m);

			l = tipi.get(m.getClass().getName());
			if(l == null)
			{
				l = new LinkedList<Media>();
				tipi.put(m.getClass().getName(), l);
			}
			l.add(m);
		}

		System.out.println("TIPI\n" + tipi);
		System.out.println("TITOLI\n" + titoli);
	}

	public String getDescription()
	{
		return "Reads Media data from named file, inserts data into Mediateca state";
	}
}
