package command;

import java.io.*;
import java.util.*;

public class SortByTitle
implements Command
{
	public void execute(Object state, Object params) throws ExecuteException
	{
		Mediateca mediateca = null;
		BufferedReader stdin = null;
		try
		{
			mediateca = (Mediateca)state;
			stdin = (BufferedReader)params;
		}
		catch(ClassCastException cce)
		{
			ExecuteException ee = new ExecuteException(cce.getMessage());
			ee.initCause(cce);
			throw ee;
		}

		ReadFromFile rff = (ReadFromFile)mediateca.comandi.get("command.ReadFromFile");
		if(rff == null)
		{
			throw new ExecuteException("No accessible data: this command depends from an instance of the command.ReadFromFile class");
		}

		String tipomedia = null;
		try
		{
			System.out.print("What media type? > ");
			tipomedia = stdin.readLine();
		}
		catch(IOException ioe)
		{
			ExecuteException ee = new ExecuteException(ioe.getMessage());
			ee.initCause(ioe);
			throw ee;
		}
		List<Media> list = rff.tipi.get(tipomedia);
		if(list == null)
		{
			System.out.println("No media of type <" + tipomedia + ">");
			return;
		}

		Collections.sort(list, new ComparaMediaPerTitolo());
		System.out.println(list);
	}

	public String getDescription()
	{
		return "Prints Media of the given type sorted by title";
	}
}
